/***************************************************************
  CPU UART VAR\[o̓Tv(荞݋쓮)
***************************************************************/

#include <intrinsics.h>

/* UARTRg[ */

#define	USE_UART_CH		0	/* UART`l0`2 */

#if (USE_UART_CH == 0)
	#define COM_BaseAdr	 0xE000C000	/* UART0 x[XAhX */
	#define UART_INT_BIT 0x00000040
#endif
#if (USE_UART_CH == 1)
	#define COM_BaseAdr	 0xE0010000	/* UART1 x[XAhX */
	#define UART_INT_BIT 0x00000080
#endif
#if (USE_UART_CH == 2)
	#define COM_BaseAdr	 0xE0078000	/* UART2 x[XAhX */
	#define UART_INT_BIT 0x10000000
#endif

#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))

/* |[gRg[ */
#define PINSEL0			((volatile unsigned int *)(0xE002C000))
#define PINSEL1			((volatile unsigned int *)(0xE002C004))

/* NbNp[Rg[ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define POW_PCONP		((volatile unsigned int *)(0xE01FC0C4))

/* 荞݃Rg[(VIC) */
#define VIC_IRQStatus	((volatile unsigned int *)(0xFFFFF000))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))


/* Œ蕶` */
const unsigned char START_TITLE[]="LPC2388 Start!!\n";

volatile unsigned char recv_data;	/* Mf[^ */
volatile int recv_flg;				/* Mf[^tO */

/* R\[pUART */
void CPU_UartInitialize(void)
{
#if (USE_UART_CH == 0)
	/* |[gUART[hɐݒ(UART0) */
	*PINSEL0=(*PINSEL0 & 0xFFFFFF0F) | 0x50;	/* TXD0&RXD0I */
	/* UART0NbN 72M/4=18MHz or 4MHz/4=1MHz */
	*CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFF3F);
	/* UART0p[Cl[u */
	*POW_PCONP = *POW_PCONP | 8;	/* UART0 */
#endif
#if (USE_UART_CH == 1)
	/* |[gUART[hɐݒ(UART1) */
	*PINSEL0=(*PINSEL0 & 0x3FFFFFFF) | 0x40000000;	/* TXD1I */
	*PINSEL1=(*PINSEL1 & 0xFFFFFFFC) | 1;			/* RXD1I */
	/* UART1NbN 72M/4=18MHz or 4MHz/4=1MHz */
	*CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFCFF);
	/* UART1p[Cl[u */
	*POW_PCONP = *POW_PCONP | 0x10;		/* UART1 */
#endif
#if (USE_UART_CH == 2)
	/* |[gUART[hɐݒ(UART2) */
	*PINSEL0=(*PINSEL0 & 0xFF0FFFFF) | 0x500000;	/* TXD2&RXD2I */
	/* UART2NbN 72M/4=18MHz or 4MHz/4=1MHz */
	*CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFCFFFF);
	/* UART2p[Cl[u */
	*POW_PCONP = *POW_PCONP | 0x01000000;	/* UART2 */
#endif

	/* 荞݃Rg[ݒ(UARTx) */
	*VIC_IntSelect = *VIC_IntSelect & (~UART_INT_BIT);
	*VIC_IntEnable = *VIC_IntEnable |   UART_INT_BIT;

	recv_flg = 0;		/* Mf[^tONA */

	/* UARTݒ */
	*COM_LCR =0x80;		/* ݒ背WX^I */
	*COM_DLL =3;		/* 1MHz19200bpsݒ */
	*COM_DLM =0;
	*COM_FDR =(/*MULVAL=*/ 12 <<4)|/*DIVADDVAL=*/1;	/* FDRWX^ݒ */
	*COM_LCR =0x03;		/* peBȂ/Xgbvrbg1/f[^8rbg */
	*COM_IER =1;		/* M荞ݎgp */
}

/* R\[1o */
void CPU_UartPutch(unsigned char data)
{
	while((*COM_LSR & 0x20)==0) {}	/* Mobt@󂭂܂ő҂ */
	*COM_THR=data;		/* Mf[^ */
}

/* R\[o(\n CR+LFo) */
void CPU_UartPuts(unsigned char *buffer)
{
	unsigned char data;
	while( (data=*(buffer++)) != 0){	/* null܂ŏo */
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[o(񒷂wt/\n CR+LFo) */
void CPU_UartPutsL(unsigned char *buffer, int len)
{
	int i;
	unsigned char data;
	for(i=0;i<len;i++){
		data=*(buffer++);
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* UARTM荞ݏ */
void CPU_UartRecvInterrupt(void)
{
	unsigned char status;
	status=*COM_IIR;			/* 荞ID擾 */
	if ((status & 0x0F) == 4) {	/* f[^M */
		recv_data= *COM_RBR;	/* Mf[^擾ۑ */
		recv_flg = 1;	/* Mf[^ */
	} else {
		recv_flg = 0;	/* Mf[^ */
	}
}

/* R\[̓obt@`FbN */
int CPU_UartRecvCheck(void)
{
	return recv_flg;	/* Mf[^tOԂ */
}

/* R\[1(GR[obNȂ) */
unsigned char CPU_UartGetch(void)
{
	while(recv_flg==0) {}	/* f[^M */
	recv_flg = 0;		/* Mf[^tONA */
	return recv_data;	/* Mf[^Ԃ */
}

/* R\[(CRR[h܂/ő255/GR[obN) */
int CPU_UartGets(unsigned char *buffer)
{
	unsigned char data;
	int	i;
	i=0;
	while(1){
		data=CPU_UartGetch();	/* 1 */
		*buffer=data;
		CPU_UartPutch(data);	/* 1o(GR[obN) */
		buffer++;
		i++;
		if (i>255) break;		/* ő啶ɒB */
		if (data==0x0d) break;	/* CRR[h܂ŎM */
	}
	*buffer=(char)0;			/* nullR[h */
	return i;					/* ͕ */
}

/* CPU荞ݏ */
__irq __arm void IRQ_Handler()
{
	int status;
	status = *VIC_IRQStatus;
	if (status & UART_INT_BIT) {	/* UARTx荞 */
		CPU_UartRecvInterrupt();	/* M荞ݏ֐ */
	}
}

/* C[` */
int main(void)
{
	unsigned char c;

	/* ^Cgo */
	CPU_UartInitialize();	/* UART */
	CPU_UartPuts((unsigned char *)START_TITLE);

	/* 荞݋ */
	__enable_interrupt();

	while(1) {
		/* R\[̓obt@`FbN */
		if (CPU_UartRecvCheck()) {
			/* R\[1(GR[obNȂ) */
			c = CPU_UartGetch();
			/* R\[1o */
			CPU_UartPutch(c);
			if (c==13) CPU_UartPutch(0x0A);	/* LFM */
		}
	}

}
